#include <pthread.h>
#include <cassert>

// divine verify -std=c++14 thread_bug01.cpp

volatile int x;

void *thread( void * ) {
    ++x;
    return nullptr;
}

int main() {
    assert( x == 0 ); // globals are initialized
    pthread_t t1, t2;
    pthread_create( &t1, nullptr, thread, nullptr );
    pthread_create( &t2, nullptr, thread, nullptr );
    assert( x <= 2 );
    assert( x >= 0 );
    pthread_join( t1, nullptr );
    pthread_join( t2, nullptr );
    assert( x == 2 );
}
